package com.swagger.rest.models

import com.fasterxml.jackson.annotation.JsonIgnore
import jakarta.persistence.*
import org.springframework.format.annotation.DateTimeFormat
import java.util.*

@Entity
@Table(name = "bug")
class Bug {

    @Id
    @Column(name = "bug_id", updatable = false, nullable = false)
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    var id: Long = 0

    @DateTimeFormat(iso = DateTimeFormat.ISO.DATE)
    var created: Date? = null

    @Column(length = 500)
    var description: String = ""

    @ManyToOne
    @JoinColumn(name = "qc", referencedColumnName = "user_id", foreignKey = ForeignKey(name = "FK_bugQc"))
    var qc: User? = null

    @ManyToOne
    @JoinColumn(name = "dev", referencedColumnName = "user_id", foreignKey = ForeignKey(name = "FK_bugDev"))
    var dev: User? = null

    @ManyToOne
    @JoinColumn(name = "platform", referencedColumnName = "platform_id", foreignKey = ForeignKey(name = "FK_bugPla"))
    var platform: Platform? = null

    var goodday_url: String = ""

    var image_url: String = ""

    @Column(columnDefinition = "TINYINT")
    var level: Int = 0

    @Column(columnDefinition = "TINYINT")
    var status: Int = 0

    @Column(columnDefinition = "TINYINT")
    var dev_status: Int = 0

    @OneToMany(mappedBy = "bug", cascade = [CascadeType.ALL])
    @JsonIgnore
    var bug: List<Comment> = mutableListOf()

}