package com.swagger.rest.models

import jakarta.persistence.*
import org.springframework.format.annotation.DateTimeFormat
import java.util.*

@Entity
@Table(name = "comment")
class Comment {

    @Id
    @Column(name = "comment_id", updatable = false, nullable = false)
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    var id: Long = 0

    @ManyToOne
    @JoinColumn(name = "bug", referencedColumnName = "bug_id", foreignKey = ForeignKey(name = "FK_commBug"))
    var bug: Bug? = null

    @ManyToOne
    @JoinColumn(name = "creator", referencedColumnName = "user_id", foreignKey = ForeignKey(name = "FK_commUser"))
    var creator: User? = null

    @DateTimeFormat(iso = DateTimeFormat.ISO.DATE)
    var created: Date? = null

    @Column(length = 500)
    var content: String = ""

}