package com.swagger.rest.models

import com.fasterxml.jackson.annotation.JsonIgnore
import jakarta.persistence.*

@Entity
@Table(name = "platform")
class Platform {

    @Id
    @Column(name = "platform_id", updatable = false, nullable = false)
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    var id: Long = 0

    @Column(name = "name", length = 100)
    var name: String = ""

    @ManyToOne
    @JoinColumn(name = "project_id", referencedColumnName = "project_id", foreignKey = ForeignKey(name = "FK_plaPro"))
    var project: Project? = null

    @OneToMany(mappedBy = "platform", cascade = [CascadeType.ALL])
    @JsonIgnore
    var platform: List<Bug> = mutableListOf()

}