package com.swagger.rest.models

import com.fasterxml.jackson.annotation.JsonIgnore
import jakarta.persistence.*
import lombok.Data


@Entity
@Table(name = "project")
class Project {

    @Id
    @Column(name = "project_id", updatable = false, nullable = false)
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    var id: Long = 0

    @Column(name = "name", length = 100)
    var name: String = ""

    @Column(name = "description")
    var description: String? = null

    @OneToMany(mappedBy = "project", cascade = [CascadeType.ALL])
    @JsonIgnore
    var project_id: List<Platform> = mutableListOf()

    @OneToMany(mappedBy = "project", cascade = [CascadeType.ALL])
    @JsonIgnore
    var member_id: List<ProjectMember> = mutableListOf()

    @ManyToOne
    @JoinColumn(name = "owner", referencedColumnName = "user_id", foreignKey = ForeignKey(name = "FK_proUser"))
    var owner: User? = null

}