package com.swagger.rest.models

import jakarta.persistence.*

@Entity
@Table(name = "project_member")
class ProjectMember {

    @Id
    @Column(name = "member_id", updatable = false, nullable = false)
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    var id: Long = 0

    @ManyToOne
    @JoinColumn(name = "project_id", referencedColumnName = "project_id", foreignKey = ForeignKey(name = "FK_memPro"))
    var project: Project? = null

    @ManyToOne
    @JoinColumn(name = "user_id", referencedColumnName = "user_id", foreignKey = ForeignKey(name = "FK_memUser"))
    var user: User? = null

    @Column(columnDefinition = "TINYINT")
    var role: Int = 0

}