package com.swagger.rest.models

import com.fasterxml.jackson.annotation.JsonIgnore
import com.fasterxml.jackson.annotation.JsonProperty
import com.opencsv.bean.CsvBindByName
import jakarta.persistence.*


@Entity
@Table(name = "user")
class User(

    @Id
    @Column(name = "user_id", updatable = false, nullable = false)
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    var id: Long = 0,

    @Column(name = "username", length = 100)
    var username: String = "",

    @JsonProperty(access = JsonProperty.Access.WRITE_ONLY)
    @Column(name = "password", length = 100)
    var password: String = "",

    @Column(name = "name", length = 255)
    var name: String = "",

    @OneToMany(mappedBy = "user", cascade = [CascadeType.ALL])
    @JsonIgnore
    var user_id: List<ProjectMember> = mutableListOf(),

    @OneToMany(mappedBy = "owner", cascade = [CascadeType.ALL])
    @JsonIgnore
    var owner: List<Project> = mutableListOf(),

    @OneToMany(mappedBy = "qc", cascade = [CascadeType.ALL])
    @JsonIgnore
    var qc: List<Bug> = mutableListOf(),

    @OneToMany(mappedBy = "dev", cascade = [CascadeType.ALL])
    @JsonIgnore
    var dev: List<Bug> = mutableListOf(),

    @OneToMany(mappedBy = "creator", cascade = [CascadeType.ALL])
    @JsonIgnore
    var creator: List<Comment> = mutableListOf()
) {
}