package com.swagger.rest.repositories

import com.swagger.rest.models.Bug
import com.swagger.rest.models.User
import org.springframework.data.domain.Page
import org.springframework.data.domain.Pageable
import org.springframework.data.jpa.repository.JpaRepository
import org.springframework.data.jpa.repository.JpaSpecificationExecutor
import org.springframework.data.jpa.repository.Query

interface BugRepository : JpaRepository<Bug, Long>, JpaSpecificationExecutor<Bug> {

    @Query("SELECT COUNT(0) FROM bug WHERE bug_id=?2 AND platform IN (SELECT platform_id FROM platform WHERE project_id IN (SELECT project_id FROM project WHERE OWNER=?1 UNION SELECT project_id FROM project_member WHERE role=2 AND user_id=?1))", nativeQuery = true)
    fun validOwnerAdmin(owner: String?, id: Long): Int

    @Query("SELECT * FROM bug WHERE platform IN (SELECT platform_id FROM platform WHERE project_id=?1)", nativeQuery = true)
    fun findByProject(project: String, pageable: Pageable): Page<Bug>

    @Query("SELECT bug_id FROM bug", nativeQuery = true)
    fun getId():List<Long>

}