package com.swagger.rest.repositories

import com.swagger.rest.models.Comment
import com.swagger.rest.models.User
import org.springframework.data.domain.Page
import org.springframework.data.domain.Pageable
import org.springframework.data.jpa.repository.JpaRepository
import org.springframework.data.jpa.repository.JpaSpecificationExecutor
import org.springframework.data.jpa.repository.Query

interface CommentRepository : JpaRepository<Comment, Long>, JpaSpecificationExecutor<Comment> {

    @Query("SELECT COUNT(0) FROM comment WHERE bug=?1", nativeQuery = true)
    fun findByBug(bug: String): Int

    @Query("SELECT * FROM comment WHERE bug=?1", nativeQuery = true)
    fun findByBug2(bug: String, pageable: Pageable): Page<Comment>

    @Query("SELECT COUNT(0) FROM COMMENT WHERE comment_id=?2 AND bug IN (SELECT bug_id FROM bug WHERE platform IN (SELECT platform FROM platform WHERE project_id IN (SELECT project_id FROM project WHERE OWNER=?1 UNION SELECT project_id FROM project_member WHERE role=2 AND user_id=?1)))", nativeQuery = true)
    fun validOwnerAdmin(user: String, id: Long): Int

    @Query("SELECT comment_id FROM comment", nativeQuery = true)
    fun getId():List<Long>

}