package com.swagger.rest.repositories

import com.swagger.rest.models.User
import org.springframework.data.jpa.repository.JpaRepository
import org.springframework.data.jpa.repository.Query

interface UserRepository : JpaRepository<User, Long> {
    @Query("SELECT u FROM User u WHERE u.username = :username")
    fun getUserByUsername(username: String): User

    fun findByUsername(username: String?): List<User>

    @Query("SELECT COUNT(0) FROM user where user_id=?1 AND username=?2", nativeQuery = true)
    fun countByUser(userId: String, username: String): Int

    @Query("SELECT user_id FROM user", nativeQuery = true)
    fun getId():List<Long>

}